import { Context } from "./signal";
declare type SuspenseState = "running" | "suspended" | "fallback";
declare type SuspenseContextType = {
    increment?: () => void;
    decrement?: () => void;
    state?: () => SuspenseState;
    initializing?: boolean;
};
declare type SuspenseConfig = {
    timeoutMs: number;
};
export declare const SuspenseContext: Context<SuspenseContextType> & {
    transition?: {
        timeoutMs: number;
        register: (p: Promise<any>) => void;
    };
};
interface ComponentType<T> {
    (props: T): any;
}
export declare function lazy<T extends ComponentType<any>>(fn: () => Promise<{
    default: T;
}>): T;
export interface Resource<T> {
    readonly value: T | undefined;
    readonly error: any;
    readonly loading: boolean;
    readonly failedAttempts: number;
    reload: (delay?: number) => void;
}
export declare function loadResource<T>(fn: () => Promise<T> | undefined): Resource<T>;
export declare function useTransition(config: SuspenseConfig): [(fn: () => any) => void, () => boolean];
export declare function awaitSuspense<T>(fn: () => T): () => T;
export {};
